{$A+,B-,D+,E-,F-,I-,L-,N-,O+,R-,S-,V-}
{$M 16384,16384,655360}

{--------------------------------------------------------------------------

TPED - A simple IDE programmer's editor for TPC

Relies very heavily on the Object Professional library by TurboPower Software.

Provided to TurboPower software for their use or public release - all
modifications by me are hereby released into the public domain.

Steve Sneed, Ozarks West Software - 25-Feb-90

----------------------------------------------------------------------------
NOTES:

I got tired of not being able to compile larger programs in the TP IDE real
fast.  I've written some pretty big programs (my current project at work is
approx 50K lines, 140K main program and 190K overlay) without having to step
out of the IDE, but with OPro I "hit the wall" very quickly.  I don't use
the IDE's debugger much, I'm just very comfortable with the editor and basic
interface.  There are several full-featured editor packages out there that
provide nice environments and offer TPC invocation (PAS-ED is an exellent
example), but I wanted mouse support and scrollbars, and... well, I just had
to do it myself. <grin>

This is a long Sunday afternoon's work, and as such it is in no way portrayed
as bulletproof or perfect, but it does provide a TPC-invoking editor that
includes automatic error-location across source files and includes a
"clipboard" functionality similar to block write/read but without disk
access - and so far it seems pretty solid (anything you find wrong with it
is far more likely to be my fault than Kim, Brian, Rich or Terry's!)

*YOU* are responsible for making sure that TPC.EXE is available in the
current dir on on the DOS path, and a proper TPC.CFG exists with a minimum of
the various paths settings (if you do not embed your default compiler
switches in your source files, you'll need to add those to TPC.CFG as well)
that the compiler can find.  The program uses the ExecDOSSwap services from
OPEXEC to maximize memory for the compiler.  It is assumed you have the
conditional compilation directive UseScrollBars $DEFINED in your compiled
OPro units that can take advantage of it; mouse support is automatic.

Planned future enhancements: *multiple file windows support (the clipboard
was done with this in mind)  *auto-config for TASM, TCC and TPC based on type
of source file loaded, including compiler invocation  *TD invocation  *Menus
and other bells and whistles.

I had fun doing this, and it sure helped familiarize me with many aspects of
OPro.  I hope you find it useful.

Steve Sneed
Ozarks West Software
25-Feb-90

---------------------------------------------------------------------------}

program TpEd;

uses
  DOS, OpCrt, ExecAccess, TPE, OpExec;

begin
  ExecAccess.ExecDOSSwap := OpExec.ExecDOSSwap;
  SetSwapMsgOn(False);
  MainEditor(ParamStr(1));
end.
